/*
 * GuiDes source code:
 *
 * Copyright 2002 Carlos Andrs <carlos.andres@navegalia.com>
 * www - http://www.geocities.com/harbour_links/guides
 *
 * GuiDes is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 *
 * GuiDes is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this software; see the file COPYING.  If not, write to
 * the Free Software Foundation, Inc., 59 Temple Place, Suite 330,
 * Boston, MA 02111-1307 USA (or visit the web site http://www.gnu.org/).
 *
 */

#include "GUIDES.CH"
#include "minigui.ch"
#include "hbclass.ch"

CREATE CLASS gTab INHERIT gControl

/*
   DATA Pictured              INIT FALSE
   DATA Caption               INIT ""
   DATA Action                INIT "{ || NIL }"
   DATA Flat                  INIT FALSE

   DATA OnGotFocus            INIT ""
   DATA OnLostFocus           INIT ""
*/

   METHOD New()      
   METHOD SetMainVars()		VIRTUAL
   METHOD Define()
   METHOD Code()
   METHOD Update()
END CLASS


METHOD New() CLASS gTab

   MsgInfo("TAB is not implemented yet." + CR_LF + "Thanks for waiting.", "GuiDes")

RETURN NIL


METHOD Define() CLASS gTab

RETURN Self


METHOD Code( oCode ) CLASS gTab
   LOCAL cCode := ""

   Super:Code( oCode )

   cCode := IIF( ::Pictured, "PICTURE", "CAPTION" )
   oCode:AddQuoted( cCode , ::Caption )
   oCode:AddTag("ACTION" , ::Action )
   oCode:AddTag("WIDTH", ::Width )
   oCode:AddTag("HEIGHT", ::Height )
   IF !( ::Pictured )
      oCode:AddQuoted("FONT", ::Font[1] )
      oCode:AddTag("SIZE", ::Font[2] )
   ENDIF
   oCode:AddNotEmptyQuoted("TOOLTIP", ::ToolTip )
   IF ::Flat            
      oCode:AddLine("FLAT")
   ENDIF      
   oCode:AddNotEmpty("ON GOTFOCUS",  ::OnGotFocus )
   oCode:AddNotEmpty("ON LOSTFOCUS", ::OnLostFocus )

   oCode:WriteToFile()
RETURN NIL


METHOD Update() CLASS gTab

   SetProperty( ::oParen:Name, ::Name, "Caption" , ::Caption )
   Super:Update()
RETURN NIL


